/*
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.0 of the PHP license,       |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_0.txt.                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Authors: Hartmut Holzgraefe <hartmut@php.net>                        |
   +----------------------------------------------------------------------+
*/

/* $ Id: $ */ 

#ifndef PHP_BRAILLE_H
#define PHP_BRAILLE_H

#ifdef  __cplusplus
extern "C" {
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <php.h>

#ifdef HAVE_BRAILLE

#include <php_ini.h>
#include <SAPI.h>
#include <ext/standard/info.h>
#include <Zend/zend_extensions.h>
#ifdef  __cplusplus
} // extern "C" 
#endif
#include <braille.h>
#ifdef  __cplusplus
extern "C" {
#endif

extern zend_module_entry braille_module_entry;
#define phpext_braille_ptr &braille_module_entry

#ifdef PHP_WIN32
#define PHP_BRAILLE_API __declspec(dllexport)
#else
#define PHP_BRAILLE_API
#endif

PHP_MINIT_FUNCTION(braille);
PHP_MSHUTDOWN_FUNCTION(braille);
PHP_RINIT_FUNCTION(braille);
PHP_RSHUTDOWN_FUNCTION(braille);
PHP_MINFO_FUNCTION(braille);

#ifdef ZTS
#include "TSRM.h"
#endif

#define FREE_RESOURCE(resource) zend_list_delete(Z_LVAL_P(resource))

#define PROP_GET_LONG(name)    Z_LVAL_P(zend_read_property(_this_ce, _this_zval, #name, strlen(#name), 1 TSRMLS_CC))
#define PROP_SET_LONG(name, l) zend_update_property_long(_this_ce, _this_zval, #name, strlen(#name), l TSRMLS_CC)

#define PROP_GET_DOUBLE(name)    Z_DVAL_P(zend_read_property(_this_ce, _this_zval, #name, strlen(#name), 1 TSRMLS_CC))
#define PROP_SET_DOUBLE(name, d) zend_update_property_double(_this_ce, _this_zval, #name, strlen(#name), d TSRMLS_CC)

#define PROP_GET_STRING(name)    Z_STRVAL_P(zend_read_property(_this_ce, _this_zval, #name, strlen(#name), 1 TSRMLS_CC))
#define PROP_GET_STRLEN(name)    Z_STRLEN_P(zend_read_property(_this_ce, _this_zval, #name, strlen(#name), 1 TSRMLS_CC))
#define PROP_SET_STRING(name, s) zend_update_property_string(_this_ce, _this_zval, #name, strlen(#name), s TSRMLS_CC)
#define PROP_SET_STRINGL(name, s, l) zend_update_property_string(_this_ce, _this_zval, #name, strlen(#name), s, l TSRMLS_CC)


PHP_FUNCTION(braille_init);
PHP_FUNCTION(braille_close);
PHP_FUNCTION(braille_geterror);
PHP_FUNCTION(braille_drivernum);
PHP_FUNCTION(braille_drivername);
PHP_FUNCTION(braille_drivermodels);
PHP_FUNCTION(braille_drivertype);
PHP_FUNCTION(braille_driverauto);
PHP_FUNCTION(braille_tablenum);
PHP_FUNCTION(braille_tablename);
PHP_FUNCTION(braille_tabledesc);
PHP_FUNCTION(braille_config);
ZEND_BEGIN_ARG_INFO(braille_config_args, 0)
  ZEND_ARG_INFO(0, arg)
ZEND_END_ARG_INFO()
PHP_FUNCTION(braille_info);
PHP_FUNCTION(braille_size);
PHP_FUNCTION(braille_statussize);
PHP_FUNCTION(braille_display);
PHP_FUNCTION(braille_write);
ZEND_BEGIN_ARG_INFO(braille_write_args, 0)
  ZEND_ARG_INFO(0, n)
ZEND_END_ARG_INFO()
PHP_FUNCTION(braille_filter);
ZEND_BEGIN_ARG_INFO(braille_filter_args, 0)
  ZEND_ARG_INFO(0, pos)
ZEND_END_ARG_INFO()
PHP_FUNCTION(braille_render);
PHP_FUNCTION(braille_statusdisplay);
PHP_FUNCTION(braille_statuswrite);
ZEND_BEGIN_ARG_INFO(braille_statuswrite_args, 0)
  ZEND_ARG_INFO(0, n)
ZEND_END_ARG_INFO()
PHP_FUNCTION(braille_statusfilter);
ZEND_BEGIN_ARG_INFO(braille_statusfilter_args, 0)
  ZEND_ARG_INFO(0, pos)
ZEND_END_ARG_INFO()
PHP_FUNCTION(braille_statusrender);
PHP_FUNCTION(braille_timeout);
PHP_FUNCTION(braille_ascii2braille);
PHP_FUNCTION(braille_braille2ascii);
PHP_FUNCTION(braille_usetable);
PHP_FUNCTION(braille_debug);
PHP_FUNCTION(braille_read);
#ifdef  __cplusplus
} // extern "C" 
#endif

#endif /* PHP_HAVE_BRAILLE */

#endif /* PHP_BRAILLE_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
